const webpackConfig = require("./webpack.config");
const CopyWebpackPlugin = require("copy-webpack-plugin");
const { NativeScriptWorkerPlugin } = require("nativescript-worker-loader/NativeScriptWorkerPlugin");

module.exports = env => {

    env = env || {};
    const config = webpackConfig(env);

    let ngCompilerPlugin, plugins = [];

    config.plugins.filter((p) => {
        if (p.constructor.name === "NativeScriptAngularCompilerPlugin") {
            ngCompilerPlugin = p;
        }
        if (p.constructor.name !== "NativeScriptWorkerPlugin") {
            plugins.push(p);
        }
    });

    const nativeScriptWorkerPlugin = new NativeScriptWorkerPlugin({
        plugins: [ngCompilerPlugin]
    });

    plugins.push(nativeScriptWorkerPlugin);

    config.plugins = plugins;

    config.module.rules.filter((p) => {
        let value = String(p.test);
        if (value == /(?:\.ngfactory\.js|\.ngstyle\.js|\.ts)$/) {
            p.exclude = /\.worker\.ts$/;
        }
    });

    let tsLoader = { test: /\.worker.ts$/, loader: "ts-loader" };

    config.module.rules.push(tsLoader);

    return config;
};