import { Component, OnInit, OnDestroy } from "@angular/core";
import { ActivatedRoute } from "@angular/router";
import * as app from "tns-core-modules/application";
import { Item } from "./item";
import { ItemService } from "./item.service";
import * as MsCognitiveservices from "nativescript-worker-loader!../../workers/mscognitiveservices.worker";
import * as permissions from "nativescript-permissions";

declare var android;

@Component({
    selector: "ns-details",
    templateUrl: "./item-detail.component.html"
})
export class ItemDetailComponent implements OnInit, OnDestroy {
    item: Item;
    public msWorker;

    constructor(
        private itemService: ItemService,
        private route: ActivatedRoute
    ) { 
        this.msWorker = new MsCognitiveservices();
        if (app.android) {
            permissions.requestPermission(android.Manifest.permission.RECORD_AUDIO).then((res) => {
                console.log(res);

            })
        }
    }

    ngOnInit(): void {
        
    }

    ngOnDestroy(){
        console.log("ngOnDestroy");
        this.msWorker.terminate();
    }

    /**
     * play
     */
    public play() {
        

        if (!this.msWorker) {
            this.msWorker = new MsCognitiveservices();
        }

        let sendInfo = {
            task: "playAudio",
            content: "I am testing"
        }

        this.msWorker.postMessage(JSON.stringify(sendInfo));

        this.msWorker.onmessage = (m) => {
            console.dir(m);
        }
    }

    /**
     * record
     */
    public record() {

        if (!this.msWorker) {
            this.msWorker = new MsCognitiveservices();
        }

        let sendInfo = {
            task: "record"
        }

        this.msWorker.postMessage(JSON.stringify(sendInfo));

        this.msWorker.onmessage = (m) => {
            console.dir(m);
        }
    }
}
