import { Component, OnInit } from "@angular/core";

import { Item } from "./item";
import { ItemService } from "./item.service";
import * as app from "tns-core-modules/application";
import * as permissions from "nativescript-permissions";
import { AudioRecorderOptions, TNSPlayer, TNSRecorder, AudioPlayerOptions } from 'nativescript-audio';
import { File, knownFolders, path } from 'tns-core-modules/file-system';
import { RouterExtensions } from "nativescript-angular/router";

declare var android, AVAudioPlayer;

@Component({
    selector: "ns-items",
    templateUrl: "./items.component.html"
})
export class ItemsComponent {
    items: Array<Item>;
    _player: TNSPlayer;
    _recorder: TNSRecorder;
    isRecording = false;
    recordFile;
    public showRecord = false;
    public speechRecognizer;
    private apiKey = "My Key";
    private region = "westus2";

    constructor(private itemService: ItemService, public routeExt: RouterExtensions) {
        this._player = new TNSPlayer();
        this._recorder = new TNSRecorder();
    }

    /**
     * nativeGate
     */
    public nativeGate() {
        this.routeExt.navigateByUrl("item");
    }

}
